# Kapitel 11d : Planetensystem

from visual import *

blowup=10 # sowie mal grösser als masstäblich
erde = sphere(pos=(0,0,0), radius=6300000*blowup, color=color.blue)
erde.v=vector(0,0,0)
erde.m=5.9e24

mond = sphere(pos=(370000000,0,0), radius=1700000*blowup, color=color.red)
mond.v = vector(0,0,370000000*6.28/(28*24*3600))   # Mondschwindigkeit : Anfangswert
mond.m= 7.3e22

dt = 1800   # Zeitschritt 30 Minuten

def kraft(A,B): # Kraft, die B auf A ausübt
    gamma=6.6e-11
    r=mag(B.pos-A.pos) # Länge des Vektors = Abstand
    return (B.pos-A.pos)*A.m*B.m*gamma/(r*r*r)
    
while True:
    rate(48) # 1s in Simulation entspricht 48*dt=24h
    mond.v+= kraft(mond,erde)/mond.m *dt
    erde.v+= kraft(erde,mond)/erde.m *dt
    mond.pos+= mond.v *dt
    erde.pos+= erde.v *dt
    if scene.mouse.events: # Damit kann der Mond durch Mausklick bewegt werden
        ev=scene.mouse.getevent()
        if ev.click: mond.pos=scene.mouse.pos
