# Kapitel 11e : Mini-Dynamische Raumgeometrie   

from visual import *

def Punkt(x,y,z):
    return sphere(pos=(x,y,z),radius=0.3,color=color.red)
def Strecke(A,B): # zwischen Punkten A und B
    return cylinder(pos=A.pos,axis=B.pos-A.pos, radius=0.1,color=color.blue)
def Ebene3P(A,B,C,size=10):
    return box(pos=A.pos,axis=(B.pos-A.pos).cross(C.pos-A.pos),
               width=size,height=size,length=0.1,
               color=color.green,opacity=0.5)
def EbenePN(A,N,size=10):
    return box(pos=A.pos,axis=N,
               width=size,height=size,length=0.1,
               color=color.green,opacity=0.5)
def setzeStrecke(S,A,B):
    S.pos=A.pos
    S.axis=B.pos-A.pos
def setzeEbene3P(E,A,B,C):
    E.pos=A.pos
    E.axis=(B.pos-A.pos).cross(C.pos-A.pos)
    E.length=0.1
def setzeEbenePN(E,A,N): # N ist Normalenvektor
    E.pos=A.pos
    E.axis=N
    E.length=0.1
    
A=Punkt(0,0,5)
B=Punkt(0,0,-5)
M=Punkt(0,0,0)
C=Punkt(0,-5,0)
E1=Ebene3P(A,B,C)
E2=EbenePN(M,A.pos-B.pos)
a=Strecke(B,C)
b=Strecke(A,C)
c=Strecke(A,B)

while True:
    event = scene.mouse.getevent() # get event
    if event.drag:
        obj=event.pick
        if obj==None: continue
        while not(scene.mouse.events): # bis zu neuem Event
            obj.pos=scene.mouse.pos
            setzeStrecke(a,B,C)
            setzeStrecke(b,A,C)
            setzeStrecke(c,A,B)
            M.pos=(A.pos+B.pos)/2 # Mittelpunkt
            setzeEbene3P(E1,A,B,C)
            setzeEbenePN(E2,M,B.pos-A.pos)

