# Kapitel 15 - CAS

def istZahl(x): return type(x)==int
def istVar(x): return type(x)==str and not(" " in x)

def istFunktion(x):
    if type(x)!=list: return False
    return len(x)>0
def istSumme(x):
    if not(istFunktion(x)): return False
    return x[0]=="+"
def istProdukt(x):
    if not(istFunktion(x)): return False
    return x[0]=="*"
def istPotenz(x):
    if not(istFunktion(x)): return False
    return x[0]=="^"

def istOp(a,op):
    if not(istFunktion(a)): return False
    return a[0]==op

def makeSumme(a,b):    return ["+",a,b]
def makeSummeL(L):
    if L==[]: return 0
    if len(L)==1: return L[0]
    return ["+"]+L
def makeDifferenz(a,b): return ["+",a,["*",-1,b]]
def makeProdukt(a,b):  return ["*",a,b]
def makeProduktL(L):
    if L==[]: return 1
    if len(L)==1: return L[0]
    return ["*"]+L
def makeQuotient(a,b): return ["*",a,["^",b,-1]]
def makePotenz(a,b):   return ["^",a,b]
def makeFunktion(f,a):  return [f,a]

def op(a): return a[0]
def opn(a,n): return a[n]

def evalNum(a): # a ist ein Zahlterm - wird ausgerechnet
    if istZahl(a): return a
    if istSumme(a): return sum([evalNum(x) for x in a[1:]])
    if istProdukt(a): return produkt([evalNum(x) for x in a[1:]])
    if istPotenz(a): return evalNum(op(a,1))**evalNum(op(a,2))
    print("Unbekannter Term: ", a, " ersetzt durch 0")
    return 0

def produkt(L):
    ergebnis=1
    for x in L: ergebnis=ergebnis*x
    return ergebnis

def diff(term,x):
    if term==x: return 1
    if istVar(term): return 0 # andere Variable als x
    if istZahl(term): return 0
    if istSumme(term):
            return makeSummeL([ diff(ex,x) for ex in term[1:]])
    if istProdukt(term):
        L=[makeProduktL(term[1:i]+[diff(term[i],x)]+term[i:]) for i in range(1,len(term))]
        return makeSummeL(L)
    if istPotenz(term):
        return makeProdukt(opn(term,2),makeProdukt(diff(opn(term,1),x),makePotenz(opn(term,1),makeDifferenz(opn(term,2),1))))
    if istFunktion(term):
        f=term[0]
        arg=opn(term,1)
        innerAbl=diff(arg,x)
        if f=="sin": return makeProdukt(innerAbl,makeFunktion("cos",arg))
        if f=="cos": return makeProdukt(innerAbl,makeProdukt(-1,makeFunktion("sin",arg)))        
    raise Exception("Leider nicht ableitbar:"+str(term))

def has(term,x): # kommt x in Term vor?
    if term==x: return True
    if istVar(term) or istZahl(term): return False
    for a in term:
        if has(a,x): return True
    return False

def subst(term,alt,neu):
    if alt==term: return neu
    if istVar(term) or istZahl(term): return term
    return [subst(a,alt,neu) for a in term]

def INTEG(term,x): 
    i=INT(term,x,5)
    if i==[]: return ["INT",term,x]
    return i

def INT(term,x,level):
    # print "INT",term,x,level
    if level<0: return [] # aussichtslos
    if term==x: return makeQuotient(makePotenz(x,2),2)
    if not(has(term,x)): return makeProdukt(term,x)
    if istSumme(term):
            res=["+"]
            for i in range(1,len(term)):
                a=opn(term,i)
                ai=INT(a,x,level-1)
                if ai==[]: return []
                res.append(ai)
            return res
    if istProdukt(term):
        if not(has(opn(term,1),x)):
            ai=INT(makeProduktL(term[2:]),x,level-1)
            if ai==[]: return []
            return vereinfache(makeProdukt(opn(term,1),ai))
        u=opn(term,1)
        v=makeProduktL(term[2:])
        vi=INT(v,x,level-1)
        if vi!=[]:
            us=vereinfache(diff(u,x))
            ii=INT(makeProdukt(us,vi),x,level-1)
            if ii!=[]: return vereinfache(makeDifferenz(makeProdukt(u,vi),ii)) 
        u=v # Vertauschen
        v=opn(term,1)
        vi=INT(v,x,level-1)
        if vi==[]: return [] 
        us=vereinfache(diff(u,x))
        ii=INT(makeProdukt(us,vi),x,level-1)
        if ii==[]: return []
        return vereinfache(makeDifferenz(makeProdukt(u,vi),ii ))
    if istPotenz(term):
        basis=opn(term,1)
        expo=opn(term,2)
        if basis==x and not(has(expo,x)):
            n1=vereinfache(makeSumme(expo,1))
            return makeQuotient(makePotenz(basis,n1),n1)
        return ["INT",term,x]
    if istFunktion(term):
        f=term[0]
        arg=opn(term,1)
        if arg==x:
            if f=="cos": return makeFunktion("sin",arg)
            if f=="sin": return makeProdukt(-1,makeFunktion("cos",arg))
    raise Exception("Leider nicht integrierbar:"+str(term))

def ausgabe(term): 
    if istZahl(term): return str(term)
    if istVar(term): return term
    if istSumme(term):
        s=""
        for i in range(1,len(term)):
            s=s+ausgabe(opn(term,i))
            if i!=len(term)-1: s=s+"+"
        return s
    if istProdukt(term):
        s=""
        for i in range(1,len(term)):
            if istSumme(opn(term,i)) :
                s=s+"("+ausgabe(opn(term,i))+")"
            else: s=s+ausgabe(opn(term,i))
            if i<len(term)-1: s=s+"*"
        return s
    if istPotenz(term):
        if istZahl(opn(term,1)) or istVar(opn(term,1)): a1=ausgabe(opn(term,1))
        else: a1="("+ausgabe(opn(term,1))+")" 
        if istZahl(opn(term,2)) or istVar(opn(term,2)): a2=ausgabe(opn(term,2))
        else: a2="("+ausgabe(opn(term,2))+")" 
        return a1+"^"+a2
    if istFunktion(term): return str(term[0])+"("+ausgabe(opn(term,1))+")"

def isGT(a,b):
    if type(a)==int and type(b)==int: return a>b
    if type(a)==str and type(b)==str: return a>b
    if type(a)==list and type(b)==list:
        if len(a)==len(b):
            if a==b: return False
            if len(a)>len(b): return True
            if len(a)<len(b): return False
            if isGT(a[0],b[0]): return True
            if isGT(b[0],a[0]): return False
            return isGT(a[1:],b[1:])            
    if type(a)==int: return False 
    if type(b)==int: return True
    if type(a)==str and type(b)==list: return False
    if type(b)==str and type(a)==list: return True
    
def mysort(L):
    if len(L)<2: return L
    L1=mysort(L[1:])
    x=L[0]
    for i in range(len(L1)):
        if not(isGT(x,L1[i])): return L1[:i]+[x]+L1[i:]
    return L1+[x]
        
def vereinfache(term):
    if istZahl(term) or istVar(term) or term==[]: return term
    if istSumme(term) or istProdukt(term):
        myop=op(term)
        args=[]
        for a in term[1:]:
            a=vereinfache(a)
            if istOp(a,myop): args=args+a[1:]
            else: args.append(a)
        args=mysort(args)
        while len(args)>1: # Summe und Differenzen ausrechnen
            if istZahl(args[0]) and istZahl(args[1]):
                if myop=="+":
                    args=[args[0]+args[1]]+args[2:]
                else:
                    args=[args[0]*args[1]]+args[2:]
                continue
            break
        if len(args)>1:
            argsneu=[]
            i=0
            while i<len(args)-1: # Gleiche Terme verarbeiten
                if args[i]==args[i+1]:
                    if myop=="+": argsneu.append(makeProdukt(2,args[i]))
                    else: argsneu.append(makePotenz(args[i],2))
                    i=i+1
                else: argsneu.append(args[i])
                i=i+1
            if args[-2]!=args[-1]: argsneu.append(args[-1])
            args=argsneu
        if args[0]==1 and myop=="*": args=args[1:]
        if args[0]==0:
            if myop=="+": args=args[1:]
            if myop=="*": args=[]
        if len(args)==1: return args[0]
        if myop=="+": return makeSummeL(args)
        else: return makeProduktL(args)
    if istPotenz(term):
        if opn(term,2)==1: return vereinfache(opn(term,1))
        if opn(term,2)==0: return 1
        return makePotenz(vereinfache(opn(term,1)),vereinfache(opn(term,2)))
    if op(term)=="diff": return vereinfache(diff(opn(term,1),opn(term,2)))
    if op(term)=="int": return vereinfache(INTEG(opn(term,1),opn(term,2)))
    if istFunktion(term):
        args=list(map(vereinfache,term[1:]))
        f=op(term)
        if f=="sin" and args[0]==0: return 0
        return [f]+args
    return term

def Vereinfache(term):
    return vereinfache(vereinfache(vereinfache(term)))


# Parser

ziffern=['0','1','2','3','4','5','6','7','8','9']
buchstaben=['a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z']
ops=[':=','=','<','>','+','*','-','/','^','(',')',',']
prez={':=':1,'=':2,'<':3,'>':3,'+':5,'*':8,'-':4,'/':8,'^':10,',':0}
funcs=["sin","cos","expand","diff","int"]

def liesZahl(s):
    global ziffern
    i=0
    for c in s:
        if c in ziffern: i=i+1
        else: break
    return [s[:i],s[i:]]

def liesVar(s):
    global ziffern, buchstaben
    if len(s)==0: return ["",""]
    if not(s[0] in buchstaben): return ["",s]
    i=1
    for c in s[1:]:
        if (c in buchstaben) or (c in ziffern): i=i+1
        else: break
    return [s[:i],s[i:]]

def liesOp(s):
    global ops
    for op in ops:
        if s.find(op)==0: return [op,s[len(op):]]
    return ["",s]

def parser(s):
    L=scanner(s)
    [L,Rest,i]=klammere(L)
    if Rest!=[]: raise Exception("Klammerstruktur falsch")
    return applyFun(elimMinDiv(vorrang(L)))

def scanner(r):
    res=[]
    while True:
        s=r.strip()
        if s=="": return res
        [z,r]=liesZahl(s)
        if z!="":
            res.append(int(z))
            continue
        [o,r]=liesOp(s)
        if o!="":
            res.append(o)
            continue
        [v,r]=liesVar(s)
        if v!="":
            res.append(v)
            continue
        raise Exception("Syntaxfehler:"+s);

def klammere(L):
    global funcs
    res=[]
    i=0
    while  i<len(L):
        if L[i]==")": return [res,L[(i+1):],i]
        if L[i]=="(":
            [a,rest,j]=klammere(L[(i+1):])
            if i>0:
                if L[i-1] in funcs:
                    a=[L[i-1]]+[a]
                    res.pop()
            i=i+j+1
            res.append(a) 
        else: res.append(L[i])
        i=i+1
    return [res,[],len(L)]
    
def vorrang(L):
    if type(L)==type(5) or type(L)==type("abc"): return L
    L=list(map(vorrang,L))
    return vorrang1(L)

def reduziere(args,op,c):
    while len(args)>1 and len(op)>0:
        if prez[op[-1]]>=prez[c]: 
            b=args.pop()
            a=args.pop()
            args.append([op.pop(),a,b])
        else: return
                    
def vorrang1(L): # L ist Liste, bei der Unterlisten schon behandelt sind
    global ops,prez, funcs
    args=[]
    op=[]
    if L[0] in funcs: return L # Nicht tun bei Funktionsanwendung
    for c in L:
        if not(c in ops): args.append(c)
        else:
            if op==[]: op.append(c)
            else:
                if prez[c]>=prez[op[-1]]: op.append(c)
                else:
                    reduziere(args,op,c)
                    op.append(c)
    while len(args)>1 and len(op)>0:
        b=args.pop()
        a=args.pop()
        args.append([op.pop(),a,b])
    return args[0]
                        
def elimMinDiv(a): # eliminier - und /
    if type(a)!=type([]): return a
    if a==[]: return a
    a=list(map(elimMinDiv,a))
    if a[0]=="-":
        if len(a)==2: return makeProdukt(-1,a[1])
        if len(a)==3: return makeDifferenz(a[1],a[2])
        raise Exception("- mit mehr als 2 args")
    if a[0]=="/":
        if len(a)==2: return makeQuotient(1,a[1])
        if len(a)==3: return makeQuotient(a[1],a[2])
        raise Exception("/ mit mehr als 2 args")
    return a

def applyFun(a): # zB ['diff', [',', 'a', 'b']] nach ['diff','a', 'b']
    if type(a)!=type([]): return a
    if a==[]: return a
    a=list(map(applyFun,a))
    if len(a)==1 or type(a[0])!=type("abc"): return a
    if type(a[1])!=type([]): return a
    if a[1][0]!=",": return a
    return [a[0]]+a[1][1:]+a[2:]


def mainloop():
    print("MiniCAS - Ende: ende, Hilfe: hilfe")    
    while True:
        eingabe=input("Eingabe? ")
        if eingabe=="ende": break
        if eingabe=="hilfe":
            print("Befehle:")
            print("Eingegebene Terme werden vereinfacht, zB: x+5+x+y+7")
            print("diff(term,var)")
            print("int(term,var)")
        term=parser(eingabe)
        aus=Vereinfache(term)
        print("Resultat: "+ausgabe(aus))
        print()


print("mainloop() startet sie Ein-Ausgabe-Schleife")

# mainloop()    # Kommentar entfernen fuer Top-Level 
