# Kapitel 4 - Daten und Zufall

import math
import random

L=[13.5, 12.9, 14.9, 14.1, 13.9, 14.0, 14.5]
 
def mittelwert(liste):
    return sum(liste)/len(liste)

def varianz(liste):
    m=mittelwert(liste)
    return mittelwert([(x-m)**2 for x in liste])

print(mittelwert(L),", ", varianz(L))


def median(L):
    sortiert=sorted(L)
    n=len(L)
    if n%2==1: # ungerade Anzahl
        return sortiert[(n-1)//2]
    return (sortiert[n//2-1]+sortiert[n//2])/2

print("Median=", median(L))

def genormt(liste): # Gibt eine Liste mit Mittelwert 0 und Standardabw .1
    m=mittelwert(liste)
    s=math.sqrt(varianz(liste)) # Standardabweichung
    return [ (x-m)/s for x in liste]

print("L normiert=",genormt(L))

def korrel(A,B):
    if len(A)!=len(B):
        print("Fehler in korrel: Ungleiche Laengen")
        return 
    An=genormt(A)
    Bn=genormt(B)
    r=0.0
    for i in range(0,len(A)): r+=An[i]*Bn[i]
    return r/len(A)

schuhe= [41,  42, 43, 44, 35, 36]
koerper=[179,185,180,177,166,165]
print("Korrelation(",schuhe,",",koerper,")=",korrel(schuhe,koerper))


# Zufallszahlen

# Simulationen des Muesli-Packungsproblems

def wartezeit():
    k=0  # Zahl der schon gekauften Packungen
    habschon=[] # schon vorhandene Figuren
    while len(habschon)<3:
        k=k+1 
        z=random.randint(1,3)
        if not( z in habschon ): habschon.append(z)
    return k

def warteNmal(n): return [ wartezeit() for i in range(n) ]

m=mittelwert(warteNmal(500))    
print("Es dauerte im Mittel ",m," Packungen")


# Hypothesentest zu Geburten

print()
print("Hypothesentest")
def geburt(): # Ergebnis ist 0=Maedchen, 1=Junge
    if random.random()<=0.51: return 1
    else: return 0

def NJungen(n): # Anzahl der Jungen bei simulierten n Geburten
    return sum([ geburt() for i in range(n) ])

# Jetzt 1000 mal 120 Geburten simulieren, zählen wenn 68 oder mehr Jungs

m=1000
n=120
g=68
k=0
for i in range(m):
    j=NJungen(n)
    if j>=g: k=k+1

p=k/m
print("p-Wert:",p," Also sind ",g," Jungs bei ",n," Geburten ", end=' ')
if p<0.05: print("signifikant auffällig")
else: print("nicht auffällig")

# Monte-Carlo

n=100000 # 100000 Tropfen
trefferZahl=0
for i in range(n):
    x=random.random()
    y=random.random()
    if x**2+y**2<1: trefferZahl+=1
p=trefferZahl/n
print("pi ist ca.: ", 4*p)
print()

# Rechtecke 
n=10000 
Umfänge=[]
Flächeninhalte=[]
for i in range(n):
    breite=random.random()
    länge=random.random()
    Umfänge.append(2*breite+2*länge)
    Flächeninhalte.append(breite*länge)
print("Umfänge Mittel=", mittelwert(Umfänge),"Stdabw=", math.sqrt(varianz(Umfänge)))
print("Flächen Mittel=", mittelwert(Flächeninhalte),"Stdabw=", math.sqrt(varianz(Flächeninhalte)))

