# Kapitel 4c: Verkehrssimulation - Stau aus dem "Nichts"
# Variation des Nagel-Schreckenberg-Modells (siehe Wikipedia)

from SWGui import *
import random
import time
from math import *

initSWGui()
Zeichenfeld=SWCanvas(width=400,height=400)

radius=9
Zeichenfeld.createCircleW(0,0,radius) # Die Strasse

# Die Position der Autos auf der Kreisbahn wird durch ihren Winkel bestimmt
# bei Radius 1 entspricht dem ja die Bogenlaenge

n=30 # Zahl der Autos
pTroedelBremsen=0.2 # Troedel-Wahrscheinlichkeit
pTroedelAnfahren=0.3 # Troedel-Wahrscheinlichkeit
autoPositionen=[]
autoGeschwindigkeiten=[] # Werte zwichen 0 und 3
autoObjekte=[]
for i in range(n):
    alpha=i*2*pi/n # Anfangs gleichverteilt
    x=cos(alpha)*radius
    y=sin(alpha)*radius
    autoPositionen.append(alpha)
    autoGeschwindigkeiten.append(2)
    autoObjekte.append(Zeichenfeld.createCircleW(x,y,0.2))

def bewege():
    global n,autoPositionen,autoGeschwindigkeiten
    for i in range(n-1,-1,-1):
        pos=autoPositionen[i]
        # Suche Vordermann
        kleinsterAbstand=10
        for j in range(n):
            pos_anderer=autoPositionen[j]
            if pos_anderer<pos: pos_anderer+=2*pi # Kreis
            if not(i==j) and pos_anderer-pos<kleinsterAbstand:
                kleinsterAbstand=pos_anderer-pos
        if kleinsterAbstand>0.15 and random.random()>pTroedelAnfahren :
            autoGeschwindigkeiten[i]+=1
        if kleinsterAbstand<0.1 or random.random()<pTroedelBremsen:
            autoGeschwindigkeiten[i]-=1
        if autoGeschwindigkeiten[i]<0: autoGeschwindigkeiten[i]=0
        if autoGeschwindigkeiten[i]>3: autoGeschwindigkeiten[i]=3
        autoPositionen[i]+=autoGeschwindigkeiten[i]/100.0
        if autoPositionen[i]>2*pi: autoPositionen[i]+=-2*pi
        
        
def stelleDar():
    global n,radius,autoPositionen,autoObjekte
    for i in range(n):
        x=radius*cos(autoPositionen[i])
        y=radius*sin(autoPositionen[i])
        autoObjekte[i].setCenterW(x,y)

for i in range(200):
    bewege()
    stelleDar()
    time.sleep(0.25)

