# Kapitel 6 Zahlentheorie

def teilt(teiler,n): return n%teiler==0

def teiler(n): return [t for t in range(1,n+1) if teilt(t,n)]

print("Die Teiler von 24 sind: ", teiler(24))

def prim(n): return len(teiler(n))==2

def primRange(a,b): return [p for p in range(a,b) if prim(p)]

def Sieb(n):
    # primzahl soll eine Liste werden, bei der an Stelle i True steht, wenn i eine PZ ist
    primzahl=[True]*(n+1) # Erstmal gehen wir davon aus, dass alle Zahlen prim sind
    primzahl[0]=False
    primzahl[1]=False
    p=2
    while True:
        i=2
        while i*p<=n: # Alle Vielfachen von p streichen
            primzahl[i*p]=False
            i+=1
        q=-1
        for z in range(p+1,n+1): # Naechste Primzahl suchen
            if primzahl[z] and q<0:
                q=z
        if q==-1: break # Keine weiteren Primzahlen gefunden, fertig
        p=q             # Die gefundene Zahl ist die naechste Primzahl
    return [p for p in range(2,n) if primzahl[p]]                
        
def Sieb2(n): # Kürzer formuliert
    # Erstmal gehen wir davon aus, dass alle Zahlen prim sind, außer 0 und 1
    p=2
    primzahl=[False,False]+[True]*(n-1) 
    while True:
        for i in range(2*p,n,p): primzahl[i]=False
        q=-1
        for z in range(p+1,n+1): # Naechste Primzahl suchen
            if primzahl[z] and q<0: q=z
        if q==-1: break # Keine weiteren Primzahlen gefunden, fertig
        p=q             # Die gefundene Zahl ist die naechste Primzahl
    return [p for p in range(2,n) if primzahl[p]]                

     

def ggt(a,b): # Definition ueber die Suche in den Teilerlisten von a und b
    ta=teiler(a)
    ta.reverse() # groesster Teiler zuerst
    tb=teiler(b)
    for t in ta:
        if t in tb: return t
    return 1

def ggT(a,b): # Rekursive Definition nach Euklid
    if a==b: return a
    if a==1 or b==1: return 1
    if a==0: return b
    if b==0: return a
    if a>b: return ggT(a%b,b)
    if a<b: return ggT(a,b%a)

def GGT(a,b): # Rekursive Definition nach Euklid - vereinfacht
    if a==0: return b
    if b==0: return a
    return GGT(b,a%b,)

    
def kgV(a,b): return a*b//ggT(a,b)


def primZerlegung(n):
    if n==1: return []
    if prim(n): return [n]
    for t in range(2,n):
        if teilt(t,n): return [t]+primZerlegung(n//t)
        
def phi(n):
    return len([i for i in range(1,n) if ggT(i,n)==1])

def EggT(a, b): # Liefert [g,x,y] mit g=x*a+y*b=ggT(a,b)
    if b>a:
        L=EggT(b,a)
        return [L[0],L[2],L[1]]
    if a==b: return [a,1,0]
    if b==0: return [a,1,0]
    q=a//b
    L=EggT(b,a%b)
    return [L[0],L[2],L[1]-q*L[2]]

def diophant(a,b,c):
    g=ggT(a,b)
    if not(teilt(g,c)): return False
    lsg=EggT(a//g,b//g)
    return [c//g*lsg[1],c//g*lsg[2]]


# RSA Kryptographie

def StrNachZahl(s): # s ist Zeichenkette von hoechstens 4 Zeichen ohne Sonderzeichen
    if len(s)>4: return -1  # Zeigt Fehler an
    codes=list(map(ord,s)) # Liste der ASCII-Code (Liste von Zahlen)
    i=0
    zahl=0
    while i<len(codes):
       zahl+=128**i*codes[i]
       i+=1
    return zahl

def ZahlNachStr(n):
    ergebnis=""
    while n>0:
        ergebnis=ergebnis+chr(n%128)
        n=n//128
    return ergebnis

t="gut"
c=StrNachZahl(t)
print("'",t,"'  als Zahl=",c," und zurück:",ZahlNachStr(c))

# Schlüsselerezugung

def nextPrime(n): # gibt nächste Primzahl nach n
    kandidat=n+1
    while not(prim(kandidat)):
        if kandidat%2==1: kandidat+=2
        else: kandidat+=1
    return kandidat


# Wahl zweier zuälliger Primzahlen:
import random
p=nextPrime(random.randint(3000,10000))
q=nextPrime(random.randint(3000,10000))
n=p*q
phiN=(p-1)*(q-1)
e=random.randint(n//3,phiN-1) # soll zu phi(n) teilerfremd sein
print("e1",e)
while not(ggT(e,phiN)==1): e+=1
print("e2",e)
# Jetzt ist e teilerfremd zu phi(n)
[d,egal]=diophant(e,phiN,1) # d ist multiplikative Inverse, kann aber noch negativ sein:
while d<0: d+=phiN

print()
print("Öffentlich n=",n," e=",e," geheim; p=",p," q=",q, "phi(n)=",phiN, "d=",d)
print("Teste, dass d, e multiplikativ invers sind: ", d*e%phiN==1)
print()

def verschlüssele(M,n,e): return M**e%n  # Richtig, aber viel zu langsam

def expmod(a,expo,n):
	if expo==0: return 1
	if expo==1: return a
	if expo%2==1: return (a*expmod(a,(expo-1)//2,n)**2)%n
	else: return (expmod(a,expo//2,n)**2)%n
	
def verschlüsseleSchnell(M,n,e): return expmod(M,e,n)

klartext="Gut"
M=StrNachZahl(klartext)
C=verschlüsseleSchnell(M,n,e)
print("verschlüsselt C=",C)

def entschlüsseleSchnell(C,n,d): return expmod(C,d,n)

Ment=entschlüsseleSchnell(C,n,d)
print("Entschlüsselter Text:", ZahlNachStr(Ment))


# Angriff durch Faktorisieren
print("Jetzt Angriff")
def faktor(n):
    p=2
    while not(teilt(p,n)):
        p=nextPrime(p)
    return p

P= faktor(n)
Q=n/P
PHI=(P-1)*(Q-1)
[D,egal]=diophant(e,PHI,1) 
while D<0: d+=PHI
Ment2=entschlüsseleSchnell(C,n,D)
print("Durch Faktorisierung entschluesselter Text:", ZahlNachStr(Ment2))
