# Kapitel 7 Numerische Algorithmen

import math

def betrag(x):
    if x<0: return -x
    else: return x

def heron(a,x=1.0):
    if betrag(a-x*x)<0.00000000001 : return x
    xneu=(x+a/x)/2
    return heron(a,xneu)

print("Wurzel aus zwei ist:", heron(2))

def quadrat(x): return x*x

# sin(x+y)=sin(x)*cos(y)+cos(x)*sin(y)
# sin(x)=sin(x/2+x/2)=2*sin(x/2)*cos(x/2)=2*sin(x/2)*sqrt(1-sin(x/2)**2)

def mysin(x):
	if betrag(x)<0.00001: return x
	sinxhalbe=mysin(x/2)
	return 2*sinxhalbe*heron(1-quadrat(sinxhalbe))

for w in range(10,100,10):
    x=w/180*math.pi
    print(w," x=",x,"sin=",math.sin(x)," mysin=",mysin(x))
	
# cos(x+y)=cos(x)*cos(y)-sin(x)*sin(y)
# cos(x)=cos(x/2)^2-sin(x/2)^2=cos(x/2)^2-(1-cos(x/2)^2)=2*cos(x/2)^2-1
def mycos(x):
	if betrag(x)<0.00001: return 1-x*x/2
	return 2*quadrat(mycos(x/2))-1

def Power(x,y):
	if y<0: return 1/Power(x,-y)
	if betrag(y-1)<0.000001: return x
	if y==0.0: return 1.0
	if y>=2: return Power(x*x,y/2)
	if y>1: return x*Power(x,y-1)
	if y<1: return Power(heron(x),2*y)
	
print("3. Wurzel aus 8 ist ", Power(8,1/3))


# Logarithmus, erste Fassung
def mylog0(x,b):
    if x<1: return -mylog0(1/x,b) # benutzt log(x)=log(1/(1/x))=-log(1/x)
    y0=0.0 # Vermuteter Logarithmus-Wert
    delta=0.001 
    while Power(b,y0)<x:
        y0=y0+delta
    return y0

print("mylog0(12,3.0)=",mylog0(12,3.0))    


# Logarithmus, zweite Fassung

def mylog(x,b):
    y1=-1000.0
    y2=1000.0
    while True:
        if y2-y1<0.000001: return (y1+y2)/2
        x1=Power(b,y1)
        x2=Power(b,y2)
        if not(x1<x and x<x2):
            print("Wert sehr gross oder sehr klein - kann ich nicht")
            return
        my=(y1+y2)/2
        mx=Power(b,my)
        if mx==x: return my # Treffer
        if mx<x:
            y1=my
        if mx>x:
            y2=my

print("mylog(12,3.0)=",mylog(12,3.0))    


def integral(f,a,b):
	n=10000
	delta=(b-a)/n
	s=0.0
	for i in range(n):
		s=s+0.5*(f(a+i*delta)+f(a+(i+1)*delta))*delta
	return s

def myln(x):
	def kehrwert(x): return 1/x
	return integral(kehrwert,1,x)

print("ln(4.2)=",math.log(4.2),":",myln(4.2))



